#! /bin/sh
#
# nodeAgent3 init script to start nodeagent daemon
#
#     Written by Maximilian Ott <max@winlab.rutgers.edu>.
#
# Version: $Id: nodeagent.init.d,v 1.1 2005/05/19 22:26:41 max Exp $
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
ETC=${ETC:-/etc}
CHUID=${CHUID:-$UID}
#
NAME=nodeagent
DESC=nodeAgent
#
PID_DIR=${PID_DIR:-/var/run/nodeagent}
PID=$PID_DIR/$NAME.pid
#
DAEMON=/usr/sbin/$NAME
#

if test ! -d $PID_DIR; then
    echo "Creating $PID_DIR"
    mkdir $PID_DIR
fi

set -e

case "$1" in
   start)
      echo -n "Starting $DESC: "
      start-stop-daemon -b -c $CHUID --start --quiet \
         -m --pidfile $PID --exec $DAEMON \
         || ( echo -n "<Failed $?>" && exit 1 )
      echo "$NAME."
      ;;
   stop)
      echo -n "Stopping $DESC: "
      start-stop-daemon -o --stop --quiet --pidfile $PID\
          --signal INT || ( echo -n "<Failed $?>" && exit 1 )
      rm -f $PID
      echo "$NAME."
      ;;
   restart)
      $0 stop
      sleep 3
      $0 start
      ;;
   test)
      start-stop-daemon --test -b -c $CHUID --start --quiet \
         -m --pidfile $PID --exec $DAEMON 
      ;;
   run)
      echo -n "Starting $DESC: "
      $DAEMON
      ;;
   *)
      N=${ETC}/init.d/$NAME
      echo "Usage: $N {start|stop|restart|test|run}" >&2
      exit 1
      ;;
esac

exit 0
