#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#include <unistd.h>

#include <netinet/in.h>
#include <net/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <sys/time.h>
#include <time.h>

#include <sys/syscall.h>
#include <errno.h>

//#include <linux/proc_fs.h>

#define __packed __attribute__((__packed__))
#include  "ieee80211.h"
 

int main(int argc, char *argv[])
{
    struct ifreq ifr;
    struct sockaddr_ll ll;
    const int protocol = ETH_P_ALL;
    int sock = -1;
    //int num_pkt = 0;
    
    int data_pkt = 0;
    int ctl_pkt = 0;
    int data_bytes = 0;
    int dpkt = 0;
    time_t t1, t2;
    int t_diff;
    int pkt_rate;
    float est_bw;
    float total_bw;
    char buf[100];
     
    total_bw = atoi(argv[2]);
    pkt_rate = atoi(argv[3]);
    est_bw = total_bw;
    printf("the total bw is %d; the pkt rate is %ld\n",total_bw,pkt_rate);
    assert(sizeof(ifr.ifr_name) == IFNAMSIZ);
    
    const char* device = argv[1];
    sock = socket(PF_PACKET, SOCK_RAW, htons(protocol));
    if (sock < 0)
    {
	    perror("socket failed\n");
	    return -1;
    }
    memset(&ifr, 0, sizeof(ifr));
    strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));
    //ifr.ifr_flags |= IFF_PROMISC;
    /*if(ioctl(sock, SIOCSIFFLAGS, &ifr) < 0)
    {
            perror("SIOCSIFFLAGS");
	    return -1;
    }*/
    if(ioctl(sock, SIOCGIFINDEX, &ifr) < 0)
    {
	    perror("ioctl[SIOCGIFINDEX]");
	    close(sock);
	    return -1;
    }
    memset(&ll, 0, sizeof(ll));
    ll.sll_family = AF_PACKET;
    ll.sll_ifindex = ifr.ifr_ifindex;
    ll.sll_protocol = htons(protocol);
    if(bind(sock, (struct sockaddr *)&ll, sizeof(ll)) < 0) {
	    perror("bind[AF_PACKET]");
	    close(sock);
	    return -1;
    }

    sprintf(buf, "echo \"%ldX%ld\" > /proc/pkt_rate\n",pkt_rate,total_bw);
    printf(buf);
    system(buf);
	
        
    //FILE* tfile;
    //if((tfile = fopen("/root/lin/mresult","w")) == NULL)
    //	    fprintf(tfile, "Cannot open %s\n", "/root/lin/mresult");
    //fprintf(tfile, "%f\n", total_bw);
    //est_bw = total_bw;
    (void)time(&t1);
    while (1) 
    {
            fd_set readfds;
	    FD_ZERO(&readfds);
	    FD_SET(sock, &readfds);
	    int numFds = select(sock+1, &readfds, NULL, NULL, NULL); //never timeout
	    assert(numFds >= 0);
	    if(numFds < 0)
	    {
                   perror("select failed");
		   return 1;
	    }
	    if(numFds == 1)
	    {
                   uint8_t packetBuffer[4096];
		   ssize_t bytes = read(sock, packetBuffer, sizeof(packetBuffer));
		   //printf("bytes = %d\n", bytes); 
		   if(bytes < 0)
		   { 
			   perror("read failed");
			   return 1;
		   }
		   if(bytes != 0) 
		   {
			   struct ieee80211_frame* mac_hdr = (struct ieee80211_frame*) packetBuffer;
			   if ( (mac_hdr->i_fc[0] & IEEE80211_FC0_TYPE_MASK) == IEEE80211_FC0_TYPE_DATA) {
			      //printf("bytes = %d\n", bytes);
			       data_pkt++;
			       data_bytes += bytes+24;
                           } else {
			       if((mac_hdr->i_fc[0] & IEEE80211_FC0_TYPE_MASK)==IEEE80211_FC0_TYPE_CTL)
			       {
				       ctl_pkt++;
				       data_bytes += 24 + bytes;
			       } 
                           }
                   }
             } 
			       //dpkt++;
	     (void)time(&t2);
			       
             //fprintf(tfile, "dpkt = %d, bytes = %d\n", dpkt, bytes);
             if((t_diff = t2 - t1) >= 1)
             {
                  printf("data_bytes = %d, data_pkt = %d,ctl_pkt = %d\n", data_bytes, data_pkt, ctl_pkt);
	          float est_bw_cur = total_bw - (data_bytes*8/1000+data_pkt*total_bw*(8*0.000009+0.000034)+ctl_pkt*total_bw*0.000016)/t_diff;
                  printf("est_bw_cur = %f, est_bw = %f\n", est_bw_cur, est_bw);
                  est_bw = est_bw/3+2*est_bw_cur/3;
            	     /*if(est_bw < 0)
		     est_bw = 0;
		     if(est_bw > total_bw)
		     est_bw = total_bw;*/
                  //est_bw = total_bw - data_bytes*8/(1000*t_diff);
                  //printf("data_bytes = %d; data_pkt = %d; t_diff = %d \n", data_bytes, data_pkt, t_diff);
                  t1 = t2;
	          data_pkt = 0;
                  ctl_pkt = 0;
                  data_bytes = 0;
                  sprintf(buf, "echo \"%ldX%ld\" > /proc/pkt_rate\n",pkt_rate,(long)est_bw);
                  printf(buf);
                  system(buf);
             }
			       
			 
			   
		   
	    }
	    
	  
    }
    //fclose(tfile);

