/* lunar_decls.h
 *
 *   LUNAR - Lightweight Underlay Network Ad hoc Routing
 *
 *   LUNAR methods and variables declaration
 *
 * Copyright (C) 2001-2003 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 */


// ----------------------------------------------------------------------
#ifndef LUNAR_DECL_H
#define LUNAR_DECL_H


//LUNAR_DECLARATIONS
#define Bmax 6000     //36M channel capacity
#define bRate 6000000  //2M basic rate
#define dRate 6000000 //36M data rate
//#define BWrsv 400

NS_EXTERN void lunar_rreq_handler(sapfpkt *p, void *aux);
NS_EXTERN void lunar_bcast_handler(sapfpkt *p, void *aux);
NS_EXTERN int  lunar_proc_info(char *buf, char **start, off_t offset, int len);
NS_STATIC void peer_timeout(void *n);
NS_STATIC void start_rreq(int ndx);
NS_STATIC void flow_timeout(void *vp);

//the following line is what I added
NS_STATIC double check_bandwidth();
//NS_STATIC void   check_bandwidth_cs(void* vp);
//NS_STATIC void   cs_timeout(void* vp);
NS_STATIC void   data_tout(void* vp);

NS_STATIC void L3deliver(sapfpkt *pkt, void *aux);

NS_STATIC int  peer_is_unknown(u_int32_t name);
NS_STATIC int  add_peer(struct in_addr name);
NS_STATIC int  add_flow(int src, int dst);
NS_STATIC struct sapfdest_s*  mkSapfDest(unsigned char *eth, sapfsel_t sel);
NS_STATIC sapfsel_t  mkNetPointer(unsigned char *eth, sapfsel_t sel);
NS_STATIC sapfsel_t  mkHandlerPointer(sapfcallback_t fct, void *aux);
NS_STATIC void  arp_answer(int ndx);

NS_STATIC int  install_peer(struct in_addr ia, sapfsel_t ptr,
			  unsigned char plen, char timeroffs);
//NS_STATIC int  install_flow(int source, int dst, double bw);
NS_STATIC void  unicast_rrep_handler(sapfpkt *p, void *ups_);
	
NS_STATIC void unicast_transit_rrep_handler(sapfpkt *p,	
					  void *tr_);
NS_STATIC void  bcast_rep_handler(sapfpkt *p,void *bps_);
	
NS_STATIC void  send_rreq(int radius, sapfsel_t series, uint32_t target,
			sapfsel_t reply, sapfsel_t backsel, int32_t src,
			sapfsel_t fwd, uint8_t hops, int32_t source,double bw);

NS_STATIC int  lunar_do_arp(struct in_addr name, long bw);
NS_STATIC void  lunar_do_bc_setup(sapfsel_t *sel, sapfpkt *pkt);
NS_STATIC void  L2sendto(sapfpkt *pkt, void *aux);

NS_STATIC void schedule_rreq(void *data, int len, unsigned long usec);


NS_EXTERN int conf_min_ring;
NS_EXTERN int conf_max_ring;
NS_EXTERN int conf_timeout_per_ring;
NS_EXTERN int conf_max_retries;
NS_EXTERN int conf_retry_wait;
NS_EXTERN int conf_fri;
NS_EXTERN int conf_fri_jitter;
NS_EXTERN int conf_rreq_gap;
NS_EXTERN int conf_data_gap;
NS_STATIC char bc_buf[2000];
NS_STATIC int bc_len;
NS_STATIC sapfsel_t bc_sel;
NS_STATIC sapfsel_t *bc_selp;
NS_STATIC char *basedevname;
NS_STATIC int debuglevel;
NS_STATIC char *forwarding;
NS_STATIC int dgwmode;
NS_STATIC int mysapfhandle;
NS_STATIC struct net_device *lunardev;
NS_STATIC struct net_device *basedev;
NS_STATIC sapfsel_t ipv4deliver;
NS_STATIC sapfsel_t bcast_selector;
//the following lines were added by me
NS_EXTERN int check_time;
NS_EXTERN int check_period;
NS_EXTERN int data_timeout; 
NS_EXTERN int resv_timeout;
//NS_EXTERN double local_bw_cs;
//NS_EXTERN double csn_bw;

//added by me+++++++++++++++++++
netbox_timer_t cs_timer, bw_timer;
//END OF LUNAR_DECLARATIONS


#endif // LUNAR_DECL_H

// eof
