/* platform.h
 *
 *   LUNAR - Lightweight Underlay Network Ad hoc Routing
 *
 *   header file with platform specific definitions
 *
 * Copyright (C) 2001-2004 <christian.tschudin@unibas.ch>
 *               2004 <evgeny.osipov@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 */

#ifndef PLATFORM_H
#define PLATFORM_H

#ifdef NS_PORT

#  include "platform_ns2.h"

#else

//General settings for both LNX/WND
#define NS_CLASS
#define NS_CLASS_addr
#define NS_CLASS_Instance_PTR
#define SAPF_CLASS
#define SAPF_Instance
#define NETBOX_CLASS
#define NETBOX_Instance
#define _VOID_VOID_ (void(*)(void*)) 
#define PACKET_TYPE 
#define NS_STATIC static
#define NS_EXTERN extern

// other common LNX/WIN stuff
#define htonsel(s) cpu_to_be64(s)
#define ntohsel(s) be64_to_cpu(s)

#ifdef WIN32
#  include "platform_win.h"
#else // Linux (Intel and ARM)
#  include "platform_lnx.h"
#endif

#endif // !NS_PORT

#ifndef MAX
#  define MAX(a,b) ((a) < (b) ? (b) : (a))
#  define MIN(a,b) ((a) < (b) ? (a) : (b))
#endif

#endif // PLATFORM_H
