/* sapf_decl.h
 *
 *   LUNAR - Lightweight Underlay Network Ad hoc Routing
 *
 *   header file for the Simple Active Packet Format,
 *   declarations only
 *
 * Copyright (C) 2001-2003 <christian.tschudin@unibas.ch>
 *
 * This file is distributed under the terms of the GNU general Public
 * License (GPL), see the file COPYING
 */

#ifndef _SAPF_DECL_H
#define _SAPF_DECL_H


// public functions:
NS_EXTERN int       sapf_init(void);
NS_EXTERN void      sapf_fini(void);

NS_EXTERN int       sapf_open(char *name, int size);
NS_EXTERN void      sapf_close(int handle);

NS_EXTERN int       sapf_demux(int handle, sapfsel_t sel, sapfpkt *p);

NS_EXTERN sapfsel_t sapf_getUnusedSelector(int handle, sapfsel_t class_);

NS_EXTERN int       sapf_addREDIR(int handle, sapfsel_t sel, sapfsel_t next);
NS_EXTERN int       sapf_addCallback(int handle, sapfsel_t sel, sapfcallback_t fct, void *aux);
NS_EXTERN int       sapf_deleteEntry(int handle, sapfsel_t sel);

NS_EXTERN int       sapf_exists(int handle, sapfsel_t sel);
NS_EXTERN int       sapf_setPermanent(int handle, sapfsel_t sel);
NS_EXTERN void*     sapf_getCallbackAux(int handle, sapfsel_t sel);
NS_EXTERN int       sapf_testandreset_active(int handle, sapfsel_t sel);

// private functions:
NS_EXTERN void      sapf_gc(unsigned long);

// private variables:
struct fibtable_s *fib[SAPF_MAX_FIB_TABLES];
unsigned char clients[SAPF_MAX_CLIENTS];

// END OF SAPF_DECLARATIONS


#endif /* _SAPF_DECL_H */
